'use client';
import { __rest, __assign } from '../../node_modules/tslib/tslib.es6.js';
import React, { useRef, useCallback, useEffect } from 'react';
import { annotate } from 'rough-notation';
import { useGroupContext } from '../RoughNotationGroup/RoughNotationGroup.js';

var RoughNotation = function (_a) {
    var _b = _a.animate, animate = _b === void 0 ? true : _b, _c = _a.animationDelay, animationDelay = _c === void 0 ? 0 : _c, _d = _a.animationDuration, animationDuration = _d === void 0 ? 800 : _d, brackets = _a.brackets, children = _a.children, color = _a.color, _e = _a.customElement, customElement = _e === void 0 ? 'span' : _e, getAnnotationObject = _a.getAnnotationObject, _f = _a.iterations, iterations = _f === void 0 ? 2 : _f, _g = _a.multiline, multiline = _g === void 0 ? false : _g, order = _a.order, _h = _a.padding, padding = _h === void 0 ? 5 : _h, _j = _a.show, show = _j === void 0 ? false : _j, _k = _a.strokeWidth, strokeWidth = _k === void 0 ? 1 : _k, _l = _a.type, type = _l === void 0 ? 'underline' : _l, rest = __rest(_a, ["animate", "animationDelay", "animationDuration", "brackets", "children", "color", "customElement", "getAnnotationObject", "iterations", "multiline", "order", "padding", "show", "strokeWidth", "type"]);
    var element = useRef(null);
    var annotation = useRef();
    var innerVars = useRef({
        playing: false,
        timeout: null,
    });
    var initialOptions = useRef({
        animate: animate,
        animationDuration: animationDuration,
        brackets: brackets,
        color: color,
        getAnnotationObject: getAnnotationObject,
        iterations: iterations,
        multiline: multiline,
        padding: padding,
        strokeWidth: strokeWidth,
        type: type,
    });
    var showAnnotation = useCallback(function () {
        if (!innerVars.current.timeout) {
            innerVars.current.timeout = window.setTimeout(function () {
                var _a, _b;
                innerVars.current.playing = true;
                (_b = (_a = annotation.current) === null || _a === void 0 ? void 0 : _a.show) === null || _b === void 0 ? void 0 : _b.call(_a);
                window.setTimeout(function () {
                    innerVars.current.playing = false;
                    innerVars.current.timeout = null;
                }, animationDuration);
            }, animationDelay);
        }
    }, [animationDelay, animationDuration]);
    var hideAnnotation = useCallback(function () {
        var _a, _b;
        (_b = (_a = annotation.current) === null || _a === void 0 ? void 0 : _a.hide) === null || _b === void 0 ? void 0 : _b.call(_a);
        innerVars.current.playing = false;
        if (innerVars.current.timeout) {
            clearTimeout(innerVars.current.timeout);
            innerVars.current.timeout = null;
        }
    }, []);
    var getAnnotation = useCallback(function () {
        return annotation.current;
    }, [annotation]);
    useGroupContext({
        getAnnotation: getAnnotation,
        show: showAnnotation,
        hide: hideAnnotation,
    }, typeof order === 'string' ? parseInt(order) : order);
    useEffect(function () {
        var options = initialOptions.current;
        var getAnnotationObjectFromOptions = options.getAnnotationObject;
        annotation.current = annotate(element.current, options);
        if (getAnnotationObjectFromOptions) {
            getAnnotationObjectFromOptions(annotation.current);
        }
        return function () {
            var _a, _b;
            (_b = (_a = annotation.current) === null || _a === void 0 ? void 0 : _a.remove) === null || _b === void 0 ? void 0 : _b.call(_a);
        };
    }, []);
    useEffect(function () {
        if (show) {
            showAnnotation();
        }
        else {
            hideAnnotation();
        }
    }, [
        annotation,
        show,
        animationDelay,
        innerVars,
        animationDuration,
        showAnnotation,
        hideAnnotation,
    ]);
    useEffect(function () {
        if (annotation.current) {
            annotation.current.animate = animate;
            annotation.current.animationDuration = animationDuration;
            annotation.current.color = color;
            annotation.current.strokeWidth = strokeWidth;
            annotation.current.padding = padding;
        }
    }, [annotation, animate, animationDuration, color, strokeWidth, padding]);
    return React.createElement(customElement, __assign({ ref: element }, rest), children);
};

export { RoughNotation as default };
//# sourceMappingURL=RoughNotation.js.map
        annotation.current.padding = padding;
        }
    }, [annotation, animate, animationDuration, color, strokeWidth, padding]);
    return React__default["default"].createElement(customElement, tslib_es6.__assign({ ref: element }, rest), children);
};

exports["default"] = RoughNotation;
//# sourceMappingURL=RoughNotation.js.map
