Object.defineProperty(exports, '__esModule', { value: true });

var tslib_es6 = require('../../node_modules/tslib/tslib.es6.js');
var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var GroupContext = React.createContext(null);
var GroupDispatchContext = React.createContext(null);
var initialState = {
    annotations: [],
};
function reducer(state, _a) {
    var type = _a.type, payload = _a.payload;
    switch (type) {
        case 'ADD': {
            var annotations = tslib_es6.__spreadArrays(state.annotations, [payload]);
            var annotationsToSort = annotations.reduce(function (toSort, annotation) {
                var newAnnotations = tslib_es6.__assign({}, toSort);
                if (typeof annotation.order === 'number') {
                    newAnnotations.withOrder = tslib_es6.__spreadArrays(newAnnotations.withOrder, [
                        annotation,
                    ]).sort(function (a, b) { return a.order - b.order; });
                }
                else {
                    newAnnotations.withoutOrder = tslib_es6.__spreadArrays(newAnnotations.withoutOrder, [
                        annotation,
                    ]);
                }
                return newAnnotations;
            }, {
                withOrder: [],
                withoutOrder: [],
            });
            return tslib_es6.__assign(tslib_es6.__assign({}, state), { annotations: tslib_es6.__spreadArrays(annotationsToSort.withOrder, annotationsToSort.withoutOrder) });
        }
        default:
            return state;
    }
}
var RoughNotationGroup = function (_a) {
    var children = _a.children, show = _a.show;
    var _b = React.useReducer(reducer, initialState), state = _b[0], dispatch = _b[1];
    var timeouts = React.useRef([]);
    React.useEffect(function () {
        var nextTimeout = 0;
        state.annotations.forEach(function (_a) {
            var annotation = _a.annotation;
            if (show) {
                var timeout = setTimeout(function () {
                    annotation.show();
                }, nextTimeout);
                timeouts.current.push(timeout);
                nextTimeout += annotation.getAnnotation().animationDuration || 800;
            }
            else {
                annotation.hide();
                timeouts.current.forEach(function (timeout) {
                    clearTimeout(timeout);
                    timeouts.current = timeouts.current.filter(function (currentTimeout) { return currentTimeout !== timeout; });
                });
            }
        });
    }, [show, state, timeouts]);
    return (React__default["default"].createElement(GroupContext.Provider, { value: state },
        React__default["default"].createElement(GroupDispatchContext.Provider, { value: dispatch }, children)));
};
var useGroupContext = function (annotation, order) {
    var context = React.useContext(GroupContext);
    var dispatch = React.useContext(GroupDispatchContext);
    var initialProps = React.useRef({ annotation: annotation, context: context, dispatch: dispatch, order: order });
    React.useEffect(function () {
        var _a = initialProps.current, currentAnnotation = _a.annotation, currentContext = _a.context, currentDispatch = _a.dispatch, currentOrder = _a.order;
        if (!currentContext) {
            return;
        }
        if (currentDispatch) {
            return currentDispatch({
                type: 'ADD',
                payload: { annotation: currentAnnotation, order: currentOrder },
            });
        }
    }, []);
};

exports["default"] = RoughNotationGroup;
exports.useGroupContext = useGroupContext;
//# sourceMappingURL=RoughNotationGroup.js.map
